@echo off
set GAMS_ENGINE_PORT=80
set GAMS_ENGINE_NWORKER=1
set GAMS_ENGINE_CRT_FILE=
set GAMS_ENGINE_CRT_KEY_FILE=
set GAMS_ENGINE_WORKER_INTERNET=n
set GAMS_ENGINE_MOUNT_PATH=
set GAMS_ENGINE_ADMIN_PASSWORD=admin
:paramloop
if x%1 == x goto usage
if %1 == -h goto usage
if %1 == /h goto usage
if x%2 == x goto usage
if %1 == -a set GAMS_ENGINE_ADMIN_PASSWORD=%2
if %1 == /a set GAMS_ENGINE_ADMIN_PASSWORD=%2
if %1 == -p set GAMS_ENGINE_PORT=%2
if %1 == /p set GAMS_ENGINE_PORT=%2
if %1 == -w set GAMS_ENGINE_NWORKER=%2
if %1 == /w set GAMS_ENGINE_NWORKER=%2
if %1 == -c set GAMS_ENGINE_CRT_FILE=%~f2
if %1 == /c set GAMS_ENGINE_CRT_FILE=%~f2
if %1 == -k set GAMS_ENGINE_CRT_KEY_FILE=%~f2
if %1 == /k set GAMS_ENGINE_CRT_KEY_FILE=%~f2
if %1 == -u set GAMS_ENGINE_WORKER_INTERNET=%2
if %1 == /u set GAMS_ENGINE_WORKER_INTERNET=%2
if %1 == -m set GAMS_ENGINE_MOUNT_PATH=%~2
if %1 == /m set GAMS_ENGINE_MOUNT_PATH=%~2
if x%3 == x goto cont
if x%4 == x goto usage
shift
shift
goto paramloop
:cont
if not "%GAMS_ENGINE_WORKER_INTERNET%" == "y" (
   if "%GAMS_ENGINE_WORKER_INTERNET%" == "Y" (
      set GAMS_ENGINE_WORKER_INTERNET=y
   ) else (
      set GAMS_ENGINE_WORKER_INTERNET=n
   )
)
if not defined GAMS_ENGINE_CRT_FILE (
   if not defined GAMS_ENGINE_PORT (
      set GAMS_ENGINE_PORT=80
      echo WARNING: Engine port is not specified will use port 80
   ) else (
      set "var="&for /f "delims=0123456789" %%i in ("%GAMS_ENGINE_PORT%") do set var=%%i
      if defined var (
         echo ERROR: Engine port is not a number
         goto usage
      )
   )
)
if not defined GAMS_ENGINE_NWORKER (
   echo ERROR: Engine number of workers is not specified
   goto usage
) else (
   set "var="&for /f "delims=0123456789" %%i in ("%GAMS_ENGINE_NWORKER%") do set var=%%i
   if defined var (
      echo ERROR: Engine number of workers is not a number
      goto usage
   )
)
echo Using port=%GAMS_ENGINE_PORT% number_of_workers=%GAMS_ENGINE_NWORKER% mount_path=/%GAMS_ENGINE_MOUNT_PATH%
if "x%GAMS_ENGINE_CRT_FILE%"=="x" PowerShell -ExecutionPolicy UnRestricted -File .\gams-engine.ps1 install -port %GAMS_ENGINE_PORT% -mount_path "%GAMS_ENGINE_MOUNT_PATH%" -worker_internet_access "%GAMS_ENGINE_WORKER_INTERNET%" -admin_password "%GAMS_ENGINE_ADMIN_PASSWORD%"
if not "x%GAMS_ENGINE_CRT_FILE%"=="x" PowerShell -ExecutionPolicy UnRestricted -File .\gams-engine.ps1 install -port %GAMS_ENGINE_PORT% -crt "%GAMS_ENGINE_CRT_FILE%" -crt_key "%GAMS_ENGINE_CRT_KEY_FILE%" -mount_path "%GAMS_ENGINE_MOUNT_PATH%" -worker_internet_access "%GAMS_ENGINE_WORKER_INTERNET%" -admin_password "%GAMS_ENGINE_ADMIN_PASSWORD%"
PowerShell -ExecutionPolicy UnRestricted -File .\gams-engine.ps1 start -workers %GAMS_ENGINE_NWORKER%
exit /b
:usage
echo Use: up.cmd /p engine_port /w number_of_workers /c certificate_file /k certificate_key_file /m mount_path /a admin_password [ /u {N^|y} ]
echo.
echo /a Admin password for the REST API, default 'admin'
echo /m Mount url for the REST API, default '/'
echo /p Port of the REST API, default '80'
echo.
echo /u Allow worker containers to access the Internet, default 'n', to allow pass 'y'
echo Due to security reasons, this is not allowed by default.
echo /w Number of worker containers to spawn
echo.
echo /c TLS certificate file path
echo /k TLS certificate key file path
if not x%1 == x-h exit /b 1
